/*
 * Copyright (C) 2008-2012 Geometer Plus <contact@geometerplus.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#include "ZLTQtPopupMenu.h"

#include "tqtimer.h"

ZLTQtPopupMenu::ZLTQtPopupMenu(TQWidget *parent) : TQPopupMenu(parent) {
	connect(this, TQ_SIGNAL(activated(int)), this, TQ_SLOT(onActivated(int)));
}

void ZLTQtPopupMenu::onActivated(int itemId) {
	myItemId = itemId;
	TQTimer::singleShot(0, this, TQ_SLOT(doActivation()) );
}

void ZLTQtPopupMenu::doActivation() {
	if (!myPopupData.isNull()) {
		myPopupData->run(myItemIdToIndex[myItemId]);
	}
}

void ZLTQtPopupMenu::reset(shared_ptr<ZLPopupData> popupData) {
	clear();
	myItemIdToIndex.clear();
	myPopupData = popupData;
	if (!popupData.isNull()) {
		const size_t count = popupData->count();
		for (size_t i = 0; i < count; ++i) {
			myItemIdToIndex[insertItem(TQString::fromUtf8(popupData->text(i).c_str()))] = i;
		}
	}
}

#include "ZLTQtPopupMenu.moc"
